use std::fs;
use clap::{App, Arg, ArgMatches, SubCommand};
use rust_util::util_clap::{Command, CommandError};
use crate::util::JsonKeyPair;
use crate::tx::{Transaction, TransactionBody};
use crate::engine::ContractEngine;
use crate::engine_plugin_credit::CreditContractCreateParameters;

pub struct CommandImpl;
impl Command for CommandImpl {
    fn name(&self) -> &str { "create" }

    fn subcommand<'a>(&self) -> App<'a, 'a> {
        SubCommand::with_name(self.name()).about("Create credit contract subcommand")
        .arg(Arg::with_name("name").long("name").short("n")
            .required(true).takes_value(true).help("Contract name")
        )
        .arg(Arg::with_name("limit").long("limit").short("l")
            .required(true).takes_value(true).help("Contract credit limit")
        )
        .arg(Arg::with_name("key").long("key").short("k")
            .required(true).takes_value(true).help("Key pair")
        )
    }
    
    fn run(&self, _arg_matches: &ArgMatches, sub_arg_matches: &ArgMatches) -> CommandError {
        let name = sub_arg_matches.value_of("name").unwrap();
        let limit = sub_arg_matches.value_of("limit").unwrap();
        let key = sub_arg_matches.value_of("key").unwrap();

        let key_json = fs::read_to_string(key)?;
        let (pri_key, pub_key) = JsonKeyPair::from_json(&key_json)?.to_key_pair()?;

        let parameters = CreditContractCreateParameters {
            name: name.into(),
            credit_limit: limit.parse()?,
        };
        let transaction_body = TransactionBody {
            timestamp: 0,
            nonce: "".into(),
            contract: "credit".into(),
            action: "create".into(),
            parameters: serde_json::to_string(&parameters)?.into(),
        };
        let tx = Transaction::new(&transaction_body, &pri_key, &pub_key)?;

        information!("Create transaction: {:#?}", tx);

        let engine = ContractEngine::new();
        engine.execute(&tx)?;

        Ok(None)
    }
}
